"""
    
    BulletsWidget
    
    Copyright 2005 Mikko Ohtamaa

"""


from AccessControl import ClassSecurityInfo
from Products.Archetypes.public import ReferenceWidget
from Products.Archetypes.public import StringWidget
from Products.Archetypes.Registry import registerWidget
    

class URLWidget(StringWidget):
    """ Editable link widget
    
    In edit mode, one can enter a link.
    
    Link validy can be checked during form submission.
    
    In view mode, the link is displayed as a HTML link.        
    """


    _properties = StringWidget._properties.copy()

    _properties.update({
        # Skin file used for this widget
        'macro' : "urlwidget",
        })
        
    security = ClassSecurityInfo()
    
    
    security.declarePublic('process_form')
    def process_form(self, instance, field, form, 
                     empty_marker=None, emptyReturnsMarker=False):
        """ Add missing http:// to url 
        
        Return tuple
            1st item: actual value
            2nd item: empty dictionary (unknown)
            ... more items?
        """
        value = StringWidget.process_form(self, instance, field, form, empty_marker, emptyReturnsMarker)
        
        if value == None or len(value) != 2: 
            return value                     
            
        string_value = value[0]
        dict = value[1]
        
        if string_value != None and len(string_value) > 0:
            if "://" not in string_value:
                string_value = "http://" + string_value
        
        return (string_value, dict)
            
registerWidget(URLWidget,
               title='URLWidget',
               description=('Editable link widget'),
               used_for=None)